stackSound = Sound.load("stack.wav")
winSound = Sound.load("win.wav")
drawSound = Sound.load("draw.wav")
breakSound = Sound.load("break.wav")
intro = Image.load("intro.png")
main = Image.load("main.png")
placed = {Image.load("black.png"),Image.load("red.png"),Image.load("yellow.png")}
new = {Image.load("nred.png"),Image.load("nyellow.png")}
board = {{1,1,1,1,1,1,1},{1,1,1,1,1,1,1},{1,1,1,1,1,1,1},{1,1,1,1,1,1,1},{1,1,1,1,1,1,1},{1,1,1,1,1,1,1}}
place =  {0,0,0,0,0,0,0}
turn=0
win=0
player=0
starter=1
x=3
exit=false

screen:blit(0, 0, intro)
screen.waitVblankStart()
screen.flip()
breakSound:play()
screen.waitVblankStart(60)
screen:blit(0, 0, main)
screen.waitVblankStart()
screen.flip()

repeat
	pad = Controls.read()
until pad:start()

while exit==false do

	screen.waitVblankStart()

	pad = Controls.read()

	if pad ~= oldPad then
		if pad:select() then
			exit=true
		end
		if pad:start() then
			screen:save("screenshot.png")
		end

		if player==0 then
			if pad:left() then
				x=x-1
				if x<=-1 then
					x=6
				end
			end
			if pad:right() then
				x=x+1
				if x>=7 then
					x=0
				end
			end
			if pad:l() then
				if place[x+1]<6 then
					stackSound:play()
					board[6-place[x+1]][x+1]=2
					place[x+1]=place[x+1]+1
					turn=turn+1
					x=3
					player=1
				end
			end
		elseif player==1 then
			if pad:square() then
				x=x-1
				if x<=-1 then
					x=6
				end
			end
			if pad:circle() then
				x=x+1
				if x>=7 then
					x=0
				end
			end
			if pad:r() then
				if place[x+1]<6 then
					stackSound:play()
					board[6-place[x+1]][x+1]=3
					place[x+1]=place[x+1]+1
					turn=turn+1
					x=3
					player=0
				end
			end
		end

		oldPad=pad
	end

	screen:clear()

	for i=1,7 do
		for j=1,6 do
			screen:blit(87+34*i, 16+34*j, placed[board[j][i]])

			if i<=4 then
				if board[j][i]==board[j][i+1] and board[j][i+1]==board[j][i+2] and board[j][i+2]==board[j][i+3] and board[j][i]~=1 then
					win=board[j][i]
				end
			end

			if j<=3 then
				if board[j][i]==board[j+1][i] and board[j+1][i]==board[j+2][i] and board[j+2][i]==board[j+3][i] and board[j][i]~=1 then
					win=board[j][i]
				end
			end

			if i<=4 and j<=3 then

				if board[j][i]==board[j+1][i+1] and board[j+1][i+1]==board[j+2][i+2] and board[j+2][i+2]==board[j+3][i+3] and board[j][i]~=1 then
					win=board[j][i]
				end

				if board[j][i+3]==board[j+1][i+2] and board[j+1][i+2]==board[j+2][i+1] and board[j+2][i+1]==board[j+3][i] and board[j][i+3]~=1 then
					win=board[j][i+3]
				end
			end

		end
	end

	if win==0 and turn~=42 then
		screen:blit(121+34*x, 6, new[player+1])
		screen:print(0,0,player+1,Color.new(255,255,255))
		screen:print(16,0,"PLAYER TURN",Color.new(255,255,255))
	end

	if win~=0 then
		screen:print(0,0,win-1,Color.new(255,255,255))
		screen:print(16,0,"PLAYER WIN!",Color.new(255,255,255))
		winSound:play()
	end

	if turn==42 then
		screen:print(0,0,"DRAW!",Color.new(255,255,255))
		drawSound:play()
	end

	if win~=0 or turn==42 then
		screen:print(0,8,"PRESS SELECT TO EXIT",Color.new(255,255,255))
		screen:print(0,16,"PRESS START TO TRY AGAIN",Color.new(255,255,255))
	end

	screen.waitVblankStart()
	screen.flip()

	if win~=0 or turn==42 then
		repeat
			screen.waitVblankStart()
			pad = Controls.read()
		until pad:select() or pad:start()
		if pad:select() then
			exit=true
		end
		if pad:start() then
			board = {{1,1,1,1,1,1,1},{1,1,1,1,1,1,1},{1,1,1,1,1,1,1},{1,1,1,1,1,1,1},{1,1,1,1,1,1,1},{1,1,1,1,1,1,1}}
			place =  {0,0,0,0,0,0,0}
			turn=0
			win=0
			player=starter
			starter=starter+1
			if starter==2 then
				starter=0
			end
			x=3
		end

	end

end
